#include <SFML/Audio.hpp>
#include <cmath>

int main()
{
    const unsigned SAMPLES = 48000*8;
	const unsigned SAMPLE_RATE = 48000;
    const double PI = 3.141592653589793238462643383;
	
	sf::Int16 raw[SAMPLES];
	
	sf::SoundBuffer Buffer;
    double x = 0;
    for (int i = 0; i < SAMPLES; i++) {
        if (i < SAMPLES/4) {
            raw[i] = 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 9/8 );
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 4/3 );
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 5/3 );
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 2/1 );
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 2/1 * 5/4 );
        } else if (i < SAMPLES/2) {
            raw[i] = 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 9/8 );
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 4/3);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 3/2);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 15/8);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 2/1 * 5/4 );
        } else if (i < 3*SAMPLES/4) {
            raw[i] = 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 );
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 5/4);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 3/2);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 15/8);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 2/1 * 9/8 );
        } else {
            raw[i] = 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 16/15);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 5/4);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 3/2);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 5/3);
            raw[i] += 6000 * sin( (double)i/SAMPLE_RATE*PI*2* 220 * 2/1 * 16/15 );
        }
    };
	if (!Buffer.loadFromSamples(raw, SAMPLES, 1, SAMPLE_RATE)) {
		return 1;
	}
	sf::Sound Sound;
	Sound.setBuffer(Buffer);
	Sound.setLoop(true);
	Sound.play();
    while (1) {
        sleep(sf::milliseconds(100));
    }
    return 0;
}